
Redmine - Feature #36205

Ruby 3.1 support

2021-11-18 01:17 - Pavel Rosický

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Ruby support Estimated time: 0.00 hour

Target version: 5.0.0   

Resolution: Fixed   

Description

net/* libraries were gemified, see https://bugs.ruby-lang.org/issues/5481

diff --git a/Gemfile b/Gemfile

index 949fe86d2..624d40216 100644

--- a/Gemfile

+++ b/Gemfile

@@ -26,6 +26,12 @@ gem 'tzinfo-data', platforms: [:mingw, :x64_mingw, :mswin]

 gem 'rotp'

 gem 'rqrcode'

+unless Gem.ruby_version < Gem::Version.new('3.1.0')

+  gem 'net-smtp', '~> 0.3.0'

+  gem 'net-imap', '~> 0.2.2'

+  gem 'net-pop', '~> 0.1.1'

+end

+

 # Optional gem for LDAP authentication

 group :ldap do

   gem 'net-ldap', '~> 0.17.0'

Related issues:

Related to Redmine - Defect #36226:  Psych 4: Psych::DisallowedClass exceptio... Closed

Related to Redmine - Defect #35435: Psych 4: aliases in database.yml cause Ps... Closed

Related to Redmine - Defect #36360: IssuesSystemTest fails with ArgumentError... Closed

Blocked by Redmine - Patch #35025: Update capybara to 3.36 Closed

Associated revisions

Revision 21296 - 2021-11-27 06:41 - Go MAEDA

Ruby 3.1: net-smtp, net-imap, and net-pop are now bundled gems (#36205).

Contributed by Pavel Rosický.

Revision 21328 - 2021-12-27 10:35 - Go MAEDA

IssuesSystemTest fails with ArgumentError in Ruby 3.1 (#36205, #36360).

Patch by Yuichi HARADA.

Revision 21329 - 2021-12-27 14:56 - Go MAEDA

Add Ruby 3.1 to the supported Ruby versions (#36205).

History

#1 - 2021-11-20 10:02 - Go MAEDA

- File 36205-v2.patch added

Pavel Rosický wrote:

net/* libraries were gemified, see https://bugs.ruby-lang.org/issues/5481
 Thank you for submitting the patch. I added some additional changes as attached to pass tests.

#2 - 2021-11-21 02:39 - Go MAEDA

- Target version set to 5.0.0

Setting the target version 5.0.0.

#3 - 2021-11-23 06:29 - Go MAEDA

- Blocked by Patch #35025: Update capybara to 3.36 added

#4 - 2021-11-23 07:54 - Go MAEDA

- Related to Defect #36226:  Psych 4: Psych::DisallowedClass exception when unserializing a setting value added

#5 - 2021-11-23 07:56 - Go MAEDA

- Related to Defect #35435: Psych 4: aliases in database.yml cause Psych::BadAlias exception added

#6 - 2021-11-26 09:47 - Go MAEDA

net-smtp, net-imap, and net-pop can be described in Gemfile even if the version of Ruby is older than 3.1.

I think using the same version of gems for all Ruby versions will make it easier to maintain Redmine.

Index: Gemfile

===================================================================

--- Gemfile    (revision 21293)

+++ Gemfile    (working copy)

@@ -18,6 +18,9 @@

 gem "rbpdf", "~> 1.20.0" 

 gem 'addressable'

 gem 'rubyzip', '~> 2.3.0'

+gem 'net-smtp', '~> 0.3.0'

+gem 'net-imap', '~> 0.2.2'

+gem 'net-pop', '~> 0.1.1'

 # Windows does not include zoneinfo files, so bundle the tzinfo-data gem

 gem 'tzinfo-data', platforms: [:mingw, :x64_mingw, :mswin]

#7 - 2021-11-26 13:42 - Pavel Rosický

It seems that Ruby 2.5 is the minimum supported version for these gems and their dependencies. So I think it's ok

#8 - 2021-11-27 06:51 - Go MAEDA

I have committed r21293, r21294, and r21296 and the trunk now passes all tests with Ruby 3.1.

I will commit the following patch after Rails officially supports Ruby 3.1.

diff --git a/Gemfile b/Gemfile

index 73ac9707d..b3f153d22 100644

--- a/Gemfile

+++ b/Gemfile

@@ -1,6 +1,6 @@

 source 'https://rubygems.org'

-ruby '>= 2.5.0', '< 3.1.0'

+ruby '>= 2.5.0', '< 3.2.0'

 gem 'bundler', '>= 1.12.0'

 gem 'rails', '6.1.4.1'

diff --git a/doc/INSTALL b/doc/INSTALL

index c0d823b3e..958e54118 100644

--- a/doc/INSTALL

+++ b/doc/INSTALL

@@ -7,7 +7,7 @@ http://www.redmine.org/

 == Requirements

-* Ruby 2.5, 2.6, 2.7, 3.0

+* Ruby 2.5, 2.6, 2.7, 3.0, 3.1

 * Bundler >= 1.12.0
 * A database:

#9 - 2021-12-27 05:04 - Go MAEDA

- Related to Defect #36360: IssuesSystemTest fails with ArgumentError in Ruby 3.1 added

#10 - 2021-12-28 01:38 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA

- Resolution set to Fixed

The trunk r21329 passes the tests with Ruby 3.1.0.

The following warning is displayed at startup due to Thor 1.1.0 but should be resolved in the future release of Thor. See 

https://github.com/rails/thor/pull/761.

Calling `DidYouMean::SPELL_CHECKERS.merge!(error_name => spell_checker)' has been deprecated. Please call `Did

YouMean.correct_error(error_name, spell_checker)' instead.

#11 - 2022-03-03 22:52 - Pavel Rosický

this change caused a small regression with starttls_auto, but it should be fixed in the mail gem https://github.com/mikel/mail/pull/1435

Files

36205-v2.patch 1.75 KB 2021-11-20 Go MAEDA
